%global upstream_name thin-provisioning-tools

Summary:		Tools for manipulating the metadata of device-mapper
Name:			device-mapper-persistent-data
Version:		0.9.0
Release:		3%{?dist}
License:		GPLv3+
URL:			https://github.com/jthornber/%{upstream_name}
Source0:		https://github.com/jthornber/%{upstream_name}/archive/refs/tags/v%{version}.tar.gz#/%{upstream_name}-%{version}.tar.gz
# Packing from the Rust community’s crate registry https://crates.io
Source1:		dmpd090-vendor3.tar.gz

Patch0001:		0001-all-Fix-resource-leaks.patch
Patch0002:		0002-thin_show_metadata-Fix-out-of-bounds-access.patch
Patch0003:		0003-build-Fix-customized-emitter-linkage.patch
Patch0004:		0004-thin_dump-Fix-leaked-shared-object-handle.patch
Patch0005:		0005-thin_show_duplicates-Fix-potential-errors.patch
Patch0006:		0006-thin_metadata_size-Fix-potential-string-overflow.patch
Patch0007:		0007-all-Fix-uninitialized-class-members.patch
Patch0008:		0008-thin_dump-Fix-warnings-on-potential-NULL-pointer.patch
Patch0009:		0009-build-Remove-unused-sources-from-the-regular-build.patch
Patch0010:		0010-all-Remove-unreachable-code.patch
Patch0011:		0011-file_utils-Fix-resource-leak.patch
Patch0012:		0012-thin_delta-Clean-up-duplicated-code.patch
Patch0013:		0013-build-Remove-lboost_iostreams-linker-flag.patch
Patch3000:		0001-Update-dependencies.patch
Patch3001:		0014-cargo-update.patch
Patch5000:		5000-avoid-stripping-in-install-stage.patch 
Patch5001:		5001-remove-rust-tools-dependency.patch

BuildRequires:	expat-devel libaio-devel libstdc++-devel boost-devel
BuildRequires:	autoconf gcc-c++ make rust-packaging rust cargo
Requires:		expat

%description
This package provides a suite of tools for manipulating the metadata
of the dm-thin, dm-cache and dm-era device-mapper targets.

%prep
%autosetup -n %{upstream_name}-%{version} -p1
tar -zxf %{SOURCE1}

mkdir -p .cargo
cat > .cargo/config <<EOF
[source.crates-io]
replace-with = "vendored-sources"

[source.vendored-sources]
directory = "vendor"

EOF

echo %{version}-%{release} > VERSION

%build
autoconf
%configure --with-optimisation=
%make_build V=
%cargo_build

%install
%make_install MANDIR=%{_mandir} install
%make_install MANDIR=%{_mandir} install-rust-tools

%files
%license COPYING
%doc README.md
%{_sbindir}/pdata_tools
%{_sbindir}/cache_check
%{_sbindir}/cache_dump
%{_sbindir}/cache_metadata_size
%{_sbindir}/cache_repair
%{_sbindir}/cache_restore
%{_sbindir}/cache_writeback
%{_sbindir}/era_check
%{_sbindir}/era_dump
%{_sbindir}/era_invalidate
%{_sbindir}/era_restore
%{_sbindir}/thin_check
%{_sbindir}/thin_delta
%{_sbindir}/thin_dump
%{_sbindir}/thin_ls
%{_sbindir}/thin_metadata_size
%{_sbindir}/thin_repair
%{_sbindir}/thin_restore
%{_sbindir}/thin_rmap
%{_sbindir}/thin_trim
%{_sbindir}/thin_metadata_pack
%{_sbindir}/thin_metadata_unpack
%{_mandir}/man8/cache_check.8.gz
%{_mandir}/man8/cache_dump.8.gz
%{_mandir}/man8/cache_metadata_size.8.gz
%{_mandir}/man8/cache_repair.8.gz
%{_mandir}/man8/cache_restore.8.gz
%{_mandir}/man8/cache_writeback.8.gz
%{_mandir}/man8/era_check.8.gz
%{_mandir}/man8/era_dump.8.gz
%{_mandir}/man8/era_invalidate.8.gz
%{_mandir}/man8/era_restore.8.gz
%{_mandir}/man8/thin_check.8.gz
%{_mandir}/man8/thin_delta.8.gz
%{_mandir}/man8/thin_dump.8.gz
%{_mandir}/man8/thin_ls.8.gz
%{_mandir}/man8/thin_metadata_size.8.gz
%{_mandir}/man8/thin_repair.8.gz
%{_mandir}/man8/thin_restore.8.gz
%{_mandir}/man8/thin_rmap.8.gz
%{_mandir}/man8/thin_trim.8.gz
%{_mandir}/man8/thin_metadata_pack.8.gz
%{_mandir}/man8/thin_metadata_unpack.8.gz

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.0-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Jul 14 2022 Xiaojie Chen <jackxjchen@tencent.com> - 0.9.0-1
- Initial build
